% O modelo multiplicador acelerador
% Exemplo tirado de [5]

% Planta 
A1=[0 1 ; -2.5 3.2]; A2=[0 1 ; -4.3 4.5]; A3=[0 1 ; 5.3 -5.2];
B1=[0 ; 1]; B2=B1; B3=B1;

% Funcional
Q1=[3.6 -3.8 ; -3.8 4.87]; Q2=[10 -3 ; -3 8]; Q3=[5 -4.5 ; -4.5 4.5];
L1=[0 ; 0]; L2=L1; L3=L1;
R1=2.6; R2=1.165; R3=1.111;

% Matriz de probabilidades de transio
P=[0.67 0.17 0.16 ; 0.3 0.47 0.23 ; 0.26 0.1 0.64];

% Opes do programa de otimizao
op=[1e-12 1e3 -1 100 0]; v=1;

% Compactao dos argumentos
Avec=stack(A1,A2,A3); Bvec=stack(B1,B2,B3);
Qvec=stack(Q1,Q2,Q3); Lvec=stack(L1,L2,L3); Rvec=stack(R1,R2,R3);

% Soluo do problema
[Fvec,Xvec] = mkvlqr(Avec,Bvec,Qvec,Lvec,Rvec,P,op,v);

% Descompactao dos resultados
[X1,X2,X3]=unstack(Xvec); [F1,F2,F3]=unstack(Fvec);

% Simulaes de Montecarlo
%x0=[1;1]; th0=1; n=40; nsim=1000; s=10;
%[Xvec,J,C] = mclqrsim(Avec,Bvec,Fvec,Qvec,Lvec,Rvec,P,x0,th0,n,nsim,s);