% Simulaes de Montecarlo para controle H2/Hinf
% Exemplo tirado de [16]

A1 = [0.9974 0.0539; -0.1078 1.1591]; 	A2 = A1;
B1 = [0.0013; 0.0539]; 			B2 = [0.0013; 0.1078];
D = [1 0; 1 0.1];
M1 = [-1 1; 0 0]; 			M2 = M1;
J1 = [0; 1];				J2 = J1;

P  = [0.7 0.3; 0.2 0.8]; nu=80;

% Vetorizando n-uplas
Avec = stack(A1,A2);
Bvec = stack(B1,B2);
Dvec = stack(D,D);
Mvec = stack(M1,M2);
Jvec = stack(J1,J2);

opt= [1e-12 1e3 -1 100 1]; v=0;

% Executando
[Fvec,upH2] = mixopt(Avec,Bvec,D,Mvec,Jvec,P,nu,opt,v);

% Simulao
x0=[0;0]; th0=1; n=100; nsim=1000; wopt=[0.5 1 1000]; s=1000;
[Z,X,W,C] = mcl2sim(Avec,Bvec,Fvec,Dvec,Mvec,Jvec,P,x0,th0,n,nsim,wopt,s);
