function sig = specrad(Gvec,P);

% SPECRAD Calculates the spectral radius of the operator L, given by
%
%		           *
%		L (.)  =  G  E (.) G
%		 i         i  i     i
%
%		where	         
%			         N
%			E (V) = sum  p   V
%			 i      j=1   ij  j
%
%	Usage: 
%		sig = specrad(Gvec,P);
%
%	where sig is the spectral radius, P is the transition probability
%	matrix and Gvec is a vectorized set of matrices compacted using 
%	the function STACK

%	RP Marques
%	Version 1.1	(03/03/97)

% Introduction

N = Gvec(2);
for i=1:N
	istr=int2str(i);
	eval(['G' istr '=unstack(Gvec,' istr ');']);
end;


% Spectral radius

n = size(G1,1);		% No checking is made. All Gs must be square and
			% have the same dimensions

V = kron(P',eye(n^2));

% Calculating H
H = zeros(N*n^2);

for i=1:N,
	istr=int2str(i);
	% aux = kron(Gi,Gi);
	eval(['aux=kron(G',istr,',G',istr,');']);
	% Building the diagonal blocks
	H((i-1)*n^2+1:i*n^2,(i-1)*n^2+1:i*n^2) = aux;
end;

sig = max(abs(eig(V*H)));
